Loading...
Searching...
No Matches
coap_oscore_internal.h File Reference

CoAP OSCORE internal information. More...

`#include "oscore/oscore_context.h"`
Include dependency graph for coap_oscore_internal.h:

Go to the source code of this file.

## Data Structures

struct | coap_oscore_conf_t
| The structure used to hold the OSCORE configuration information. More...

## Typedefs

typedef enum oscore_partial_iv_t | oscore_partial_iv_t

## Enumerations

enum | oscore_partial_iv_t { OSCORE_SEND_NO_IV , OSCORE_SEND_PARTIAL_IV }

## Functions

COAP_API coap_pdu_t * | coap_oscore_new_pdu_encrypted (coap_session_t *session, coap_pdu_t *pdu, coap_bin_const_t *kid_context, oscore_partial_iv_t send_partial_iv)
| Encrypts the specified `pdu` when OSCORE encryption is required on `session`.
coap_pdu_t * | coap_oscore_new_pdu_encrypted_lkd (coap_session_t *session, coap_pdu_t *pdu, coap_bin_const_t *kid_context, oscore_partial_iv_t send_partial_iv)
| Encrypts the specified `pdu` when OSCORE encryption is required on `session`.
struct coap_pdu_t * | coap_oscore_decrypt_pdu (coap_session_t *session, coap_pdu_t *pdu)
| Decrypts the OSCORE-encrypted parts of `pdu` when OSCORE is used.
void | coap_delete_all_oscore (coap_context_t *context)
| Cleanup all allocated OSCORE information.
void | coap_delete_oscore_associations (coap_session_t *session)
| Cleanup all allocated OSCORE association information.
size_t | coap_oscore_overhead (coap_session_t *session, coap_pdu_t *pdu)
| Determine the additional data size requirements for adding in OSCORE.
int | coap_rebuild_pdu_for_proxy (coap_pdu_t *pdu)
| Convert PDU to use Proxy-Scheme option if Proxy-Uri option is present.
int | coap_oscore_initiate (coap_session_t *session, coap_oscore_conf_t *oscore_conf)
| Initiate an OSCORE session.
int | coap_context_oscore_server_lkd (coap_context_t *context, coap_oscore_conf_t *oscore_conf)
| Set the context's default OSCORE configuration for a server.
int | coap_delete_oscore_recipient_lkd (coap_context_t *context, coap_bin_const_t *recipient_id)
| Release all the information associated for the specific Recipient ID (and hence and stop any further OSCORE protection for this Recipient).
coap_session_t * | coap_new_client_session_oscore_lkd (coap_context_t *ctx, const coap_address_t *local_if, const coap_address_t *server, coap_proto_t proto, coap_oscore_conf_t *oscore_conf)
| Creates a new client session to the designated server, protecting the data using OSCORE.
coap_session_t * | coap_new_client_session_oscore_pki_lkd (coap_context_t *ctx, const coap_address_t *local_if, const coap_address_t *server, coap_proto_t proto, coap_dtls_pki_t *pki_data, coap_oscore_conf_t *oscore_conf)
| Creates a new client session to the designated server with PKI credentials as well as protecting the data using OSCORE.
coap_session_t * | coap_new_client_session_oscore_psk_lkd (coap_context_t *ctx, const coap_address_t *local_if, const coap_address_t *server, coap_proto_t proto, coap_dtls_cpsk_t *psk_data, coap_oscore_conf_t *oscore_conf)
| Creates a new client session to the designated server with PSK credentials as well as protecting the data using OSCORE.
int | coap_new_oscore_recipient_lkd (coap_context_t *context, coap_bin_const_t *recipient_id)
| Add in the specific Recipient ID into the OSCORE context (server only).

## Detailed Description

CoAP OSCORE internal information.

Definition in file coap_oscore_internal.h.